OGRE: Ogre::Font Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Ogre::Font Class Reference
Core » Resources

Class representing a font in the system. More...

`#include <OgreFont.h>`

Inheritance diagram for Ogre::Font:
[legend]

## Classes
struct | GlyphInfo
| Information about the position and size of a glyph in a texture. More...

## Public Types
typedef Ogre::uint32 | CodePoint
typedef std::pair< CodePoint, CodePoint > | CodePointRange
| A range of code points, inclusive on both ends. More...
typedef vector< CodePointRange >::type | CodePointRangeList
enum | LoadingFlags { LF_DEFAULT = 0, LF_INCLUDE_NON_RELOADABLE = 1, LF_ONLY_UNREFERENCED = 2, LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE = 3, LF_PRESERVE_STATE = 4 }
| Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior. More...
enum | LoadingState { LOADSTATE_UNLOADED, LOADSTATE_LOADING, LOADSTATE_LOADED, LOADSTATE_UNLOADING, LOADSTATE_PREPARED, LOADSTATE_PREPARING }
| Enum identifying the loading state of the resource. More...
typedef Ogre::FloatRect | UVRect

## Public Member Functions
| Font (ResourceManager *creator, const String &name, ResourceHandle handle, const String &group, bool isManual=false, ManualResourceLoader *loader=0)
| Constructor. More...
virtual | ~Font ()
virtual void | _dirtyState ()
| Manually mark the state of this resource as having been changed. More...
virtual void | _fireLoadingComplete (bool wasBackgroundLoaded)
| Firing of loading complete event. More...
virtual void | _firePreparingComplete (bool wasBackgroundLoaded)
| Firing of preparing complete event. More...
virtual void | _fireUnloadingComplete (void)
| Firing of unloading complete event. More...
virtual void | _notifyOrigin (const String &origin)
| Notify this resource of it's origin. More...
void | addCodePointRange (const CodePointRange &range)
| Adds a range of code points to the list of code point ranges to generate glyphs for, if this is a truetype based font. More...
virtual void | addListener (Listener *lis)
| Register a listener on this resource. More...
virtual void | changeGroupOwnership (const String &newGroup)
| Change the resource group ownership of a Resource. More...
void | clearCodePointRanges ()
| Clear the list of code point ranges. More...
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object. More...
virtual void | escalateLoading ()
| Escalates the loading of a background loaded resource. More...
bool | getAntialiasColour (void) const
| Gets whether or not the colour of this font is antialiased as it is generated from a true type font. More...
uint | getCharacterSpacer (void) const
| Gets the spacing to allocate for font characters to overlap each other. More...
const CodePointRangeList & | getCodePointRangeList () const
| Get a const reference to the list of code point ranges to be used to generate glyphs from a truetype font. More...
virtual ResourceManager * | getCreator (void)
| Gets the manager which created this resource. More...
Real | getGlyphAspectRatio (CodePoint id) const
| Gets the aspect ratio (width / height) of this character. More...
const GlyphInfo & | getGlyphInfo (CodePoint id) const
| Gets the information available for a glyph corresponding to a given code point, or throws an exception if it doesn't exist;. More...
const UVRect & | getGlyphTexCoords (CodePoint id) const
| Returns the texture coordinates of the associated glyph. More...
virtual const String & | getGroup (void) const
| Gets the group which this resource is a member of. More...
virtual ResourceHandle | getHandle (void) const
HlmsDatablock * | getHlmsDatablock ()
| Gets the HLMS Datablock generated for this font. More...
virtual LoadingState | getLoadingState () const
| Returns the current loading state. More...
virtual const String & | getName (void) const
| Gets resource name. More...
virtual const String & | getOrigin (void) const
| Get the origin of this resource, e.g. More...
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class. More...
const ParamDictionary * | getParamDictionary (void) const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method. More...
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object. More...
virtual size_t | getSize (void) const
| Retrieves info about the size of the resource. More...
const String & | getSource (void) const
| Gets the source this font (either an image or a truetype font). More...
virtual size_t | getStateCount () const
| Returns the number of times this resource has changed state, which generally means the number of times it has been loaded. More...
int | getTrueTypeMaxBearingY () const
| Gets the maximum baseline distance of all glyphs used in the texture. More...
uint | getTrueTypeResolution (void) const
| Gets the resolution (dpi) of the font used to generate the texture. More...
Real | getTrueTypeSize (void) const
| Gets the point size of the font used to generate the texture. More...
FontType | getType (void) const
| Gets the type of font. More...
virtual bool | isBackgroundLoaded (void) const
| Returns whether this Resource has been earmarked for background loading. More...
virtual bool | isLoaded (void) const
| Returns true if the Resource has been loaded, false otherwise. More...
virtual bool | isLoading () const
| Returns whether the resource is currently in the process of background loading. More...
virtual bool | isManuallyLoaded (void) const
| Is this resource manually loaded? More...
virtual bool | isPrepared (void) const
| Returns true if the Resource has been prepared, false otherwise. More...
virtual bool | isReloadable (void) const
| Returns true if the Resource is reloadable, false otherwise. More...
virtual void | load (bool backgroundThread=false)
| Loads the resource, if it is not already. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | prepare (bool backgroundThread=false)
| Prepares the resource for load, if it is not already. More...
virtual void | reload (LoadingFlags flags=LF_DEFAULT)
| Reloads the resource, if it is already loaded. More...
virtual void | removeListener (Listener *lis)
| Remove a listener on this resource. More...
void | setAntialiasColour (bool enabled)
| Sets whether or not the colour of this font is antialiased as it is generated from a true type font. More...
virtual void | setBackgroundLoaded (bool bl)
| Tells the resource whether it is background loaded or not. More...
void | setCharacterSpacer (uint charSpacer)
| Sets the spacing to allocate for font characters to overlap each other. More...
void | setGlyphAspectRatio (CodePoint id, Real ratio)
| Sets the aspect ratio (width / height) of this character. More...
void | setGlyphTexCoords (CodePoint id, Real u1, Real v1, Real u2, Real v2, Real textureAspect)
| Sets the texture coordinates of a glyph. More...
virtual void | setManuallyLoaded (bool isManual)
| Set "Is this resource manually loaded?". More...
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method. More...
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method. More...
void | setSource (const String &source)
| Sets the source of the font. More...
virtual void | setToLoaded (void)
| Change the Resource loading state to loaded. More...
void | setTrueTypeResolution (uint ttfResolution)
| Gets the resolution (dpi) of the font used to generate the texture (only required for FT_TRUETYPE). More...
void | setTrueTypeSize (Real ttfSize)
| Sets the size of a truetype font (only required for FT_TRUETYPE). More...
void | setType (FontType ftype)
| Sets the type of font. More...
virtual void | touch (void)
| 'Touches' the resource to indicate it has been used. More...
virtual void | unload (void)
| Unloads the resource; this is not permanent, the resource can be reloaded later if required. More...

## Static Public Member Functions
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g. More...

## Public Attributes
| OGRE_AUTO_MUTEX

## Detailed Description

Class representing a font in the system.

Remarks
  This class is simply a way of getting a font texture into the OGRE system and to easily retrieve the texture coordinates required to accurately render them. Fonts can either be loaded from precreated textures, or the texture can be generated using a truetype font. You can either create the texture manually in code, or you can use a .fontdef script to define it (probably more practical since you can reuse the definition more easily)

Note
  This class extends both Resource and ManualResourceLoader since it is both a resource in it's own right, but it also provides the manual load implementation for the Texture it creates.

## Member Typedef Documentation

## ◆ CodePoint

typedef Ogre::uint32 Ogre::Font::CodePoint

## ◆ CodePointRange

typedef std::pair<CodePoint, CodePoint> Ogre::Font::CodePointRange

A range of code points, inclusive on both ends.

## ◆ CodePointRangeList

typedef vector<CodePointRange>::type Ogre::Font::CodePointRangeList

## ◆ UVRect

typedef Ogre::FloatRect Ogre::Font::UVRect

## Member Enumeration Documentation

## ◆ LoadingFlags

enum Ogre::Resource::LoadingFlags
| inherited

Enum that allow to choose subset of unloaded/reloaded resources and to adjust reloading behavior.

Enumerator
LF_DEFAULT | Only reloadable resources are processed, reload restores initial state.
LF_INCLUDE_NON_RELOADABLE | Process non-reloadable resources too.
LF_ONLY_UNREFERENCED | Process only resources which are not referenced by any other object. Usefull to reduce resource consumption.
LF_ONLY_UNREFERENCED_INCLUDE_NON_RELOADABLE | Combination of LF_ONLY_UNREFERENCED and LF_INCLUDE_NON_RELOADABLE.
LF_PRESERVE_STATE | Preserve some states during reloading, for example stencil shadows prepareness for Meshes.

## ◆ LoadingState

enum Ogre::Resource::LoadingState
| inherited

Enum identifying the loading state of the resource.

Enumerator
LOADSTATE_UNLOADED | Not loaded.
LOADSTATE_LOADING | Loading is in progress.
LOADSTATE_LOADED | Fully loaded.
LOADSTATE_UNLOADING | Currently unloading.
LOADSTATE_PREPARED | Fully prepared.
LOADSTATE_PREPARING | Preparing is in progress.

## Constructor & Destructor Documentation

## ◆ Font()

Ogre::Font::Font | ( | ResourceManager * | creator,
|  | const String & | name,
|  | ResourceHandle | handle,
|  | const String & | group,
|  | bool | isManual = `false`,
|  | ManualResourceLoader * | loader = `0`
| ) |  |

Constructor.

See also
  Resource

## ◆ ~Font()

virtual Ogre::Font::~Font | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _dirtyState()

virtual void Ogre::Resource::_dirtyState | ( |  | ) |
| virtualinherited

Manually mark the state of this resource as having been changed.

Remarks
  You only need to call this from outside if you explicitly want derived objects to think this object has changed.

See also
  getStateCount.

## ◆ _fireLoadingComplete()

virtual void Ogre::Resource::_fireLoadingComplete | ( | bool | wasBackgroundLoaded | ) |
| virtualinherited

Firing of loading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _firePreparingComplete()

virtual void Ogre::Resource::_firePreparingComplete | ( | bool | wasBackgroundLoaded | ) |
| virtualinherited

Firing of preparing complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

Parameters

  wasBackgroundLoaded | Whether this was a background loaded event

## ◆ _fireUnloadingComplete()

virtual void Ogre::Resource::_fireUnloadingComplete | ( | void |  | ) |
| virtualinherited

Firing of unloading complete event.

Remarks
  You should call this from the thread that runs the main frame loop to avoid having to make the receivers of this event thread-safe. If you use Ogre's built in frame loop you don't need to call this yourself.

## ◆ _notifyOrigin()

virtual void Ogre::Resource::_notifyOrigin | ( | const String & | origin | ) |
| inlinevirtualinherited

Notify this resource of it's origin.

## ◆ addCodePointRange()

void Ogre::Font::addCodePointRange | ( | const CodePointRange & | range | ) |
| inline

Adds a range of code points to the list of code point ranges to generate glyphs for, if this is a truetype based font.

Remarks
  In order to save texture space, only the glyphs which are actually needed by the application are generated into the texture. Before this object is loaded you must call this method as many times as necessary to define the code point range that you need.

## ◆ addListener()

virtual void Ogre::Resource::addListener | ( | Listener * | lis | ) |
| virtualinherited

Register a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ changeGroupOwnership()

virtual void Ogre::Resource::changeGroupOwnership | ( | const String & | newGroup | ) |
| virtualinherited

Change the resource group ownership of a Resource.

Remarks
  This method is generally reserved for internal use, although if you really know what you're doing you can use it to move this resource from one group to another.

Parameters

  newGroup | Name of the new group

## ◆ cleanupDictionary()

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) |
| staticinherited

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

## ◆ clearCodePointRanges()

void Ogre::Font::clearCodePointRanges | ( |  | ) |
| inline

Clear the list of code point ranges.

## ◆ copyParametersTo()

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const
| inlinevirtualinherited

Method for copying this object's parameters to another object.

Remarks
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters

  dest | Pointer to object to have it's parameters set the same as this object.

References Ogre::StringInterface::setParameter().

## ◆ escalateLoading()

virtual void Ogre::Resource::escalateLoading | ( |  | ) |
| virtualinherited

Escalates the loading of a background loaded resource.

Remarks
  If a resource is set to load in the background, but something needs it before it's been loaded, there could be a problem. If the user of this resource really can't wait, they can escalate the loading which basically pulls the loading into the current thread immediately. If the resource is already being loaded but just hasn't quite finished then this method will simply wait until the background load is complete.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getAntialiasColour()

bool Ogre::Font::getAntialiasColour | ( | void |  | ) | const
| inline

Gets whether or not the colour of this font is antialiased as it is generated from a true type font.

## ◆ getCharacterSpacer()

uint Ogre::Font::getCharacterSpacer | ( | void |  | ) | const

Gets the spacing to allocate for font characters to overlap each other.

Remarks
  Returns the size of the character spacer, in points. A higher value allows for more stretched-out fonts. A low value reduces memory and processing time. The default is "5".

## ◆ getCodePointRangeList()

const CodePointRangeList& Ogre::Font::getCodePointRangeList | ( |  | ) | const
| inline

Get a const reference to the list of code point ranges to be used to generate glyphs from a truetype font.

## ◆ getCreator()

virtual ResourceManager* Ogre::Resource::getCreator | ( | void |  | ) |
| inlinevirtualinherited

Gets the manager which created this resource.

## ◆ getGlyphAspectRatio()

Real Ogre::Font::getGlyphAspectRatio | ( | CodePoint | id | ) | const
| inline

Gets the aspect ratio (width / height) of this character.

## ◆ getGlyphInfo()

const GlyphInfo& Ogre::Font::getGlyphInfo | ( | CodePoint | id | ) | const

Gets the information available for a glyph corresponding to a given code point, or throws an exception if it doesn't exist;.

## ◆ getGlyphTexCoords()

const UVRect& Ogre::Font::getGlyphTexCoords | ( | CodePoint | id | ) | const
| inline

Returns the texture coordinates of the associated glyph.

Remarks
  Parameter is a short to allow both ASCII and wide chars.

Parameters

  id | The code point (unicode)

Returns
  A rectangle with the UV coordinates, or null UVs if the code point was not present

## ◆ getGroup()

virtual const String& Ogre::Resource::getGroup | ( | void |  | ) | const
| inlinevirtualinherited

Gets the group which this resource is a member of.

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getHandle()

virtual ResourceHandle Ogre::Resource::getHandle | ( | void |  | ) | const
| inlinevirtualinherited

Reimplemented in Ogre::v1::OldSkeletonInstance.

## ◆ getHlmsDatablock()

HlmsDatablock* Ogre::Font::getHlmsDatablock | ( |  | ) |
| inline

Gets the HLMS Datablock generated for this font.

Remarks
  This will only be valid after the Font has been loaded.

## ◆ getLoadingState()

virtual LoadingState Ogre::Resource::getLoadingState | ( |  | ) | const
| inlinevirtualinherited

Returns the current loading state.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ getName()

virtual const String& Ogre::Resource::getName | ( | void |  | ) | const
| inlinevirtualinherited

Gets resource name.

Reimplemented in Ogre::v1::OldSkeletonInstance.

Referenced by Ogre::GpuProgramUsage::getProgramName().

## ◆ getOrigin()

virtual const String& Ogre::Resource::getOrigin | ( | void |  | ) | const
| inlinevirtualinherited

Get the origin of this resource, e.g.

a script file name.

Remarks
  This property will only contain something if the creator of this resource chose to populate it. Script loaders are advised to populate it.

## ◆ getParamDictionary() [1/2]

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) |
| inlineinherited

Retrieves the parameter dictionary for this class.

Remarks
  Only valid to call this after createParamDictionary.

Returns
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

## ◆ getParamDictionary() [2/2]

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const
| inlineinherited

## ◆ getParameter()

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const
| inlinevirtualinherited

Generic parameter retrieval method.

Remarks
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters

  name | The name of the parameter to get

Returns
  String value of parameter, blank if not found

References Ogre::ParamCommand::doGet().

## ◆ getParameters()

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const
| inherited

Retrieves a list of parameters valid for this object.

Returns
  A reference to a static list of ParameterDef objects.

## ◆ getSize()

virtual size_t Ogre::Resource::getSize | ( | void |  | ) | const
| inlinevirtualinherited

Retrieves info about the size of the resource.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ getSource()

const String& Ogre::Font::getSource | ( | void |  | ) | const

Gets the source this font (either an image or a truetype font).

## ◆ getStateCount()

virtual size_t Ogre::Resource::getStateCount | ( |  | ) | const
| inlinevirtualinherited

Returns the number of times this resource has changed state, which generally means the number of times it has been loaded.

Objects that build derived data based on the resource can check this value against a copy they kept last time they built this derived data, in order to know whether it needs rebuilding. This is a nice way of monitoring changes without having a tightly-bound callback.

## ◆ getTrueTypeMaxBearingY()

int Ogre::Font::getTrueTypeMaxBearingY | ( |  | ) | const

Gets the maximum baseline distance of all glyphs used in the texture.

Remarks
  Only applicable for FT_TRUETYPE Font objects. The baseline is the vertical origin of horizontal based glyphs. The bearingY attribute is the distance from the baseline (origin) to the top of the glyph's bounding box.

Note
  This value is only available after the font has been loaded.

## ◆ getTrueTypeResolution()

uint Ogre::Font::getTrueTypeResolution | ( | void |  | ) | const

Gets the resolution (dpi) of the font used to generate the texture.

Remarks
  Only applicable for FT_TRUETYPE Font objects.

## ◆ getTrueTypeSize()

Real Ogre::Font::getTrueTypeSize | ( | void |  | ) | const

Gets the point size of the font used to generate the texture.

Remarks
  Only applicable for FT_TRUETYPE Font objects. Note that the size of the font does not affect how big it is on the screen, just how large it is in the texture and thus how detailed it is.

## ◆ getType()

FontType Ogre::Font::getType | ( | void |  | ) | const

Gets the type of font.

## ◆ isBackgroundLoaded()

virtual bool Ogre::Resource::isBackgroundLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether this Resource has been earmarked for background loading.

Remarks
  This option only makes sense when you have built Ogre with thread support (OGRE_THREAD_SUPPORT). If a resource has been marked for background loading, then it won't load on demand like normal when load() is called. Instead, it will ignore request to load() except if the caller indicates it is the background loader. Any other users of this resource should check isLoaded(), and if that returns false, don't use the resource and come back later.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ isLoaded()

virtual bool Ogre::Resource::isLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource has been loaded, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ isLoading()

virtual bool Ogre::Resource::isLoading | ( |  | ) | const
| inlinevirtualinherited

Returns whether the resource is currently in the process of background loading.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

References Ogre::AtomicScalar< T >::get().

## ◆ isManuallyLoaded()

virtual bool Ogre::Resource::isManuallyLoaded | ( | void |  | ) | const
| inlinevirtualinherited

Is this resource manually loaded?

## ◆ isPrepared()

virtual bool Ogre::Resource::isPrepared | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource has been prepared, false otherwise.

References Ogre::AtomicScalar< T >::get().

## ◆ isReloadable()

virtual bool Ogre::Resource::isReloadable | ( | void |  | ) | const
| inlinevirtualinherited

Returns true if the Resource is reloadable, false otherwise.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ load()

virtual void Ogre::Resource::load | ( | bool | backgroundThread = `false` | ) |
| virtualinherited

Loads the resource, if it is not already.

Remarks
  If the resource is loaded from a file, loading is automatic. If not, if for example this resource gained it's data from procedural calls rather than loading from a file, then this resource will not reload on it's own.

Parameters

  backgroundThread | Indicates whether the caller of this method is the background resource loading thread.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ prepare()

virtual void Ogre::Resource::prepare | ( | bool | backgroundThread = `false` | ) |
| virtualinherited

Prepares the resource for load, if it is not already.

One can call prepare() before load(), but this is not required as load() will call prepare() itself, if needed. When OGRE_THREAD_SUPPORT==1 both load() and prepare() are thread-safe. When OGRE_THREAD_SUPPORT==2 however, only prepare() is thread-safe. The reason for this function is to allow a background thread to do some of the loading work, without requiring the whole render system to be thread-safe. The background thread would call prepare() while the main render loop would later call load(). So long as prepare() remains thread-safe, subclasses can arbitrarily split the work of loading a resource between load() and prepare(). It is best to try and do as much work in prepare(), however, since this will leave less work for the main render thread to do and thus increase FPS.

Parameters

  backgroundThread | Whether this is occurring in a background thread

## ◆ reload()

virtual void Ogre::Resource::reload | ( | LoadingFlags | flags = `LF_DEFAULT` | ) |
| virtualinherited

Reloads the resource, if it is already loaded.

Remarks
  Calls unload() and then load() again, if the resource is already loaded. If it is not loaded already, then nothing happens.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram, and Ogre::v1::Mesh.

## ◆ removeListener()

virtual void Ogre::Resource::removeListener | ( | Listener * | lis | ) |
| virtualinherited

Remove a listener on this resource.

See also
  Resource::Listener

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ setAntialiasColour()

void Ogre::Font::setAntialiasColour | ( | bool | enabled | ) |
| inline

Sets whether or not the colour of this font is antialiased as it is generated from a true type font.

Remarks
  This is valid only for a FT_TRUETYPE font. If you are planning on using alpha blending to draw your font, then it is a good idea to set this to false (which is the default), otherwise the darkening of the font will combine with the fading out of the alpha around the edges and make your font look thinner than it should. However, if you intend to blend your font using a colour blending mode (add or modulate for example) then it's a good idea to set this to true, in order to soften your font edges.

## ◆ setBackgroundLoaded()

virtual void Ogre::Resource::setBackgroundLoaded | ( | bool | bl | ) |
| inlinevirtualinherited

Tells the resource whether it is background loaded or not.

Remarks

See also
  Resource::isBackgroundLoaded . Note that calling this only defers the normal on-demand loading behaviour of a resource, it does not actually set up a thread to make sure the resource gets loaded in the background. You should use ResourceBackgroundLoadingQueue to manage the actual loading (which will call this method itself).

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## ◆ setCharacterSpacer()

void Ogre::Font::setCharacterSpacer | ( | uint | charSpacer | ) |

Sets the spacing to allocate for font characters to overlap each other.

Parameters

  charSpacer | The size of the character spacer, in points. Increasing it allows for more stretched-out fonts; decreasing it reduces memory and processing time. The default is "5".

## ◆ setGlyphAspectRatio()

void Ogre::Font::setGlyphAspectRatio | ( | CodePoint | id,
|  | Real | ratio
| ) |  |
| inline

Sets the aspect ratio (width / height) of this character.

Remarks
  You only need to call this if you're setting up a font loaded from a texture manually.

## ◆ setGlyphTexCoords()

void Ogre::Font::setGlyphTexCoords | ( | CodePoint | id,
|  | Real | u1,
|  | Real | v1,
|  | Real | u2,
|  | Real | v2,
|  | Real | textureAspect
| ) |  |
| inline

Sets the texture coordinates of a glyph.

Remarks
  You only need to call this if you're setting up a font loaded from a texture manually.

Note
  Also sets the aspect ratio (width / height) of this character. textureAspect is the width/height of the texture (may be non-square)

## ◆ setManuallyLoaded()

virtual void Ogre::Resource::setManuallyLoaded | ( | bool | isManual | ) |
| inlinevirtualinherited

Set "Is this resource manually loaded?".

## ◆ setParameter()

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value
| ) |  |
| virtualinherited

Generic parameter setting method.

Remarks
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  name | The name of the parameter to set
  value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

## ◆ setParameterList()

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) |
| virtualinherited

Generic multiple parameter setting method.

Remarks
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters

  paramList | Name/value pair list

## ◆ setSource()

void Ogre::Font::setSource | ( | const String & | source | ) |

Sets the source of the font.

Remarks
  If you have created a font of type FT_IMAGE, this method tells the Font which image to use as the source for the characters. So the parameter should be the name of an appropriate image file. Note that when using an image as a font source, you will also need to tell the font where each character is located using setGlyphTexCoords (for each character).

  If you have created a font of type FT_TRUETYPE, this method tells the Font which .ttf file to use to generate the text. You will also need to call setTrueTypeSize and setTrueTypeResolution, and call addCodePointRange as many times as required to define the range of glyphs you want to be available.

Parameters

  source | An image file or a truetype font, depending on the type of this font

## ◆ setToLoaded()

virtual void Ogre::Resource::setToLoaded | ( | void |  | ) |
| inlinevirtualinherited

Change the Resource loading state to loaded.

References Ogre::AtomicScalar< T >::set().

## ◆ setTrueTypeResolution()

void Ogre::Font::setTrueTypeResolution | ( | uint | ttfResolution | ) |

Gets the resolution (dpi) of the font used to generate the texture (only required for FT_TRUETYPE).

Parameters

  ttfResolution | The resolution in dpi

## ◆ setTrueTypeSize()

void Ogre::Font::setTrueTypeSize | ( | Real | ttfSize | ) |

Sets the size of a truetype font (only required for FT_TRUETYPE).

Parameters

  ttfSize | The size of the font in points. Note that the size of the font does not affect how big it is on the screen, just how large it is in the texture and thus how detailed it is.

## ◆ setType()

void Ogre::Font::setType | ( | FontType | ftype | ) |

Sets the type of font.

Must be set before loading.

## ◆ touch()

virtual void Ogre::Resource::touch | ( | void |  | ) |
| virtualinherited

'Touches' the resource to indicate it has been used.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram, and Ogre::Material.

Referenced by Ogre::Material::touch().

## ◆ unload()

virtual void Ogre::Resource::unload | ( | void |  | ) |
| virtualinherited

Unloads the resource; this is not permanent, the resource can be reloaded later if required.

Reimplemented in Ogre::UnifiedHighLevelGpuProgram.

## Member Data Documentation

## ◆ OGRE_AUTO_MUTEX

Ogre::Resource::OGRE_AUTO_MUTEX
| inherited

The documentation for this class was generated from the following file:

- OgreFont.h